/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppStoragePoolLister helps list NetAppStoragePools.
// All objects returned here must be treated as read-only.
type NetAppStoragePoolLister interface {
	// List lists all NetAppStoragePools in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppStoragePool, err error)
	// NetAppStoragePools returns an object that can list and get NetAppStoragePools.
	NetAppStoragePools(namespace string) NetAppStoragePoolNamespaceLister
	NetAppStoragePoolListerExpansion
}

// netAppStoragePoolLister implements the NetAppStoragePoolLister interface.
type netAppStoragePoolLister struct {
	indexer cache.Indexer
}

// NewNetAppStoragePoolLister returns a new NetAppStoragePoolLister.
func NewNetAppStoragePoolLister(indexer cache.Indexer) NetAppStoragePoolLister {
	return &netAppStoragePoolLister{indexer: indexer}
}

// List lists all NetAppStoragePools in the indexer.
func (s *netAppStoragePoolLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppStoragePool, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppStoragePool))
	})
	return ret, err
}

// NetAppStoragePools returns an object that can list and get NetAppStoragePools.
func (s *netAppStoragePoolLister) NetAppStoragePools(namespace string) NetAppStoragePoolNamespaceLister {
	return netAppStoragePoolNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppStoragePoolNamespaceLister helps list and get NetAppStoragePools.
// All objects returned here must be treated as read-only.
type NetAppStoragePoolNamespaceLister interface {
	// List lists all NetAppStoragePools in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppStoragePool, err error)
	// Get retrieves the NetAppStoragePool from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppStoragePool, error)
	NetAppStoragePoolNamespaceListerExpansion
}

// netAppStoragePoolNamespaceLister implements the NetAppStoragePoolNamespaceLister
// interface.
type netAppStoragePoolNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppStoragePools in the indexer for a given namespace.
func (s netAppStoragePoolNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppStoragePool, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppStoragePool))
	})
	return ret, err
}

// Get retrieves the NetAppStoragePool from the indexer for a given namespace and name.
func (s netAppStoragePoolNamespaceLister) Get(name string) (*v1alpha1.NetAppStoragePool, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappstoragepool"), name)
	}
	return obj.(*v1alpha1.NetAppStoragePool), nil
}
