//go:generate go run generator.go

package staticcontent

type embedStaticContent struct {
	storage map[string][]byte
}

// Create new StaticContent for embed files
func newEmbedStaticContent() *embedStaticContent {
	return &embedStaticContent{storage: make(map[string][]byte)}
}

// Add a file to StaticContent
func (e *embedStaticContent) Add(file string, content []byte) {
	e.storage[file] = content
}

// Get file's content
func (e *embedStaticContent) Get(file string) []byte {
	if f, ok := e.storage[file]; ok {
		return f
	}
	return nil
}

// Embed StaticContent expose
var staticContent = newEmbedStaticContent()

// Add a file content to StaticContent
func Add(file string, content []byte) {
	staticContent.Add(file, content)
}

// Get a file from StaticContent
func Get(file string) []byte {
	return staticContent.Get(file)
}
