package util

import "sync"

// LockingInt is a lockable int
type LockingInt struct {
	sync.RWMutex
	data int
}

// NewLockingInt creates a new LockingInt
func NewLockingInt() LockingInt {
	return LockingInt{}
}

// Set will lock and set a lockingInt
func (i *LockingInt) Set(val int) {
	i.Lock()
	defer i.Unlock()
	i.data = val
}

// Get will Rlock and get a lockingInt
func (i *LockingInt) Get() int {
	i.RLock()
	defer i.RUnlock()
	return i.data
}
